/*
 * MyDeployMBeanImpl.java
 *
 * Created on September 14, 2006, 11:59 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package jsr88deploymbean;

import java.io.File;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;
import java.util.jar.Manifest;
import javax.enterprise.deploy.spi.Target;
import javax.management.MBeanServerConnection;
import javax.management.ObjectName;
import javax.management.remote.JMXConnector;
import javax.management.remote.JMXConnectorFactory;
import javax.management.remote.JMXServiceURL;

/**
 *
 * @author bhavani
 */
public class MyDeploy implements MyDeployMBean {
    
    /** Creates a new instance of MyDeployMBeanImpl */
    public MyDeploy() {
    }
    
    class DeployTask implements Runnable {
        
        String archivePath = null;
        
        DeployTask(String archivePath) {
            this.archivePath = archivePath;
        }
        
        private void doJSR88Deploy() {
            try {
                File file = new File(
                        System.getProperty("com.sun.aas.installRoot")
                        + File.separator+ "lib" + File.separator + "deployment"
                        + File.separator + "sun-as-jsr88-dm.jar");
                System.err.println("file :: " + file.getAbsolutePath());
                Manifest mf = new java.util.jar.JarFile(file).getManifest();
                String className = mf.getMainAttributes().getValue("J2EE-DeploymentFactory-Implementation-Class");
                System.err.println("classname :: " + className);
                URL[] urls = new URL[]{file.toURL()};
                URLClassLoader urlClassLoader = new URLClassLoader(urls, getClass().getClassLoader());
                Class factory = null;
                try {
                    factory=urlClassLoader.loadClass(className);
                } catch (ClassNotFoundException cnfe) {
                    cnfe.printStackTrace();
                }
                
                Object df = null;
                try {
                    df = factory.newInstance();
                } catch (Exception ie) {
                    ie.printStackTrace();
                }
                if (df instanceof javax.enterprise.deploy.spi.factories.DeploymentFactory) {
                    javax.enterprise.deploy.shared.factories.DeploymentFactoryManager.getInstance().registerDeploymentFactory((javax.enterprise.deploy.spi.factories.DeploymentFactory) df);
                } else {
                    System.err.println("df is not instance of DeploymentFacility");
                    return;
                }
                javax.enterprise.deploy.spi.DeploymentManager dm = javax.enterprise.deploy.shared.factories.DeploymentFactoryManager.getInstance().getDeploymentManager("deployer:Sun:AppServer::localhost:4848", "admin", "adminadmin");
                System.err.println("df :: " + df.getClass().getName() + ", dm :: " + dm);
                Target[] allTargets = dm.getTargets();
                System.err.println("calling deploy....");
                javax.enterprise.deploy.spi.status.ProgressObject po = dm.distribute(allTargets, new File(archivePath), null);
                System.err.println("waiting for deployment status....");
                // Wait for 5 minutes to complete the deploment. No successful deployment will take more than 5 minutes.
                Thread.currentThread().sleep(300000);
                javax.enterprise.deploy.spi.status.DeploymentStatus status = po.getDeploymentStatus();
                if(status.isCompleted()) {
                    System.err.println("deployment successful...");
                } else {
                    System.err.println("deployment failed...");
                }
            } catch(Exception ex) {
                ex.printStackTrace();
            }
        }
        
        public void run() {
            doJSR88Deploy();
        }
    }
    
    public boolean deploy(String archivePath) {
        try {
            System.err.println("Deploy called....");
            DeployTask dt = new DeployTask(archivePath);
            dt.run();
            return true;
        } catch(Exception ex) {
            ex.printStackTrace();
            return false;
        }
    }
    
}
