/*
 * Copyright 2006 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 */

package jsr88deploymbean;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Iterator;
import java.util.Properties;
import java.util.Set;
import java.util.Map;
import java.util.HashMap;
import javax.management.MBeanServerConnection;
import javax.management.ObjectName;
import javax.management.remote.JMXConnector;
import javax.management.remote.JMXConnectorFactory;
import javax.management.remote.JMXServiceURL;

public class MyDeployClient {
    
    /**
     * Lists MBeans
     */

	private MBeanServerConnection mbsc = null;
	private JMXConnector jmxc = null;

	public void init() {
		try {
            String adminUser = "admin";
            String adminPassword = "adminadmin";
            String jmxServiceURL = "service:jmx:rmi:///jndi/rmi://localhost:8686/jmxrmi";
            String[] credentials = new String[] { adminUser, adminPassword };
            Map env = new HashMap();
            env.put("jmx.remote.credentials", credentials);
            
            JMXServiceURL url = new JMXServiceURL(jmxServiceURL);
            jmxc = JMXConnectorFactory.connect(url, env);
            mbsc = jmxc.getMBeanServerConnection();
        } catch(Exception ex) {
            ex.printStackTrace();
		}
	}

	public void clean() {
		try {
            jmxc.close();
        } catch(Exception ex) {
            ex.printStackTrace();
		}
	}

	public void invokeDeploy() {
		try {
			ObjectName jsr88deploymbean = new ObjectName("user:impl-class-name=jsr88deploymbean.MyDeploy,name=jsr88deploymbean.MyDeploy,server=server");
			Object[] params = new Object[] { "/tmp/hello/hello.war" };
			String[] signatures = new String[] { "java.lang.String" };
			mbsc.invoke(jsr88deploymbean, "deploy", params, signatures); 
		} catch(Exception ex) {
			ex.printStackTrace();
		}
	}

    public MyDeployClient(){
    }
    
    public static void main(String[] args) {
        MyDeployClient client = new MyDeployClient();
		client.init();
		//client.listMBeans();
		//client.queryMBean(args[0]);
		client.invokeDeploy();
		client.clean();
    }
    
}
